﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=11.2
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
End Sub

Sub Service_Create
	
	DateTime.DateFormat = "ddMMyyyy"
	DateTime.TimeFormat = "HH:mm"
	DateTime.SetTimeZone(1)
	Log(DateTime.date(DateTime.Now) & " " & DateTime.time(DateTime.Now))
	'Log(DateTime.Time(DateTime.Now))
	'Dim time_zone As Long = DateTime.TimeZoneOffset*3600000
	
	
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	
	StartServiceAt(Me,DateTime.Now + 10000,True) ' Relance toutes les 10s
	
	'******************** Charge le fichier Setup Heater  **************
		
	If File.Exists(File.DirDefaultExternal, "Heater-Setup.json") Then
		wait for (JsonFileAction.Read_JSONfileMap("Heater-Setup.json")) complete  (DataMap As Map)
	End If
	
	If ServerMQTT.HeaterSetup.IsInitialized Then
		ServerMQTT.HeaterSetup=DataMap
	End If
	
	'******************** Charge le fichier Setup Heater Local  **************
	
	If File.Exists(File.DirDefaultExternal, "LocalHeater-Setup.json") Then
		wait for (JsonFileAction.Read_JSONfileMap("LocalHeater-Setup.json")) complete  (LocalDataMap As Map)
	End If
		
	If ServerMQTT.LocalHeaterSetup.IsInitialized Then
		ServerMQTT.LocalHeaterSetup=LocalDataMap
	End If
	
	
	
	If IsPaused(SmsReader)=True Then
		StartService(SmsReader)
	End If
	
	If IsPaused(ServerMQTT)=True Or ServerMQTT.connected=False Then
		StartService(ServerMQTT)
	End If
	
	
	
	Log(SmsReader.SchedulerCommand.IsInitialized & ServerMQTT.connected)
	
	If SmsReader.SchedulerCommand.IsInitialized And ServerMQTT.connected=True Then
		SmsReader.SchedulerCommand.Clear
		wait for (JsonFileAction.Read_JSONfile("scheduler.json")) complete  (ReturnlList As List)
		SmsReader.SchedulerCommand= ReturnlList
		ControlScheduler
	Else
		StopService(Me)
	End If
	
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	
End Sub

Sub ControlScheduler
	
	Private ListofScheduler As Map
	Private ActiveHeater As Boolean=False
	Private SchedulerZoneTemp As String=""
	
	Try
			
	
		For Each L_Map As Map In SmsReader.SchedulerCommand
			Private RefSplit() As String = Regex.Split(" ", L_Map.GetKeyAt(0))
			Private SchedulerId As Int = RefSplit(1)
			Private DaysList As List
			Private ValideDate As Boolean=False
			
			DaysList.Initialize
			
			ListofScheduler= L_Map.Get(L_Map.GetKeyAt(0))
			'Log("Programme: " & SchedulerId)
			'Contrôle si programme actif
			If 	ListofScheduler.Get("SchedulerActive")=SchedulerId & ";" & "true" Then
				
				If ListofScheduler.Get("SchedulerDate")<>"-;-" Then 'Activation par date
					Private DatetimeProg() As String =	Regex.Split(";",ListofScheduler.Get("SchedulerDate"))
					Private DateTimeStart() As String =Regex.Split("/",DatetimeProg(0))
					Private DateTimeStop() As String =Regex.Split("/",DatetimeProg(1))
					
					If DateTime.now>= DateTime.DatetimeParse(DateTimeStart(0),DateTimeStart(1))	And DateTime.now<= DateTime.DatetimeParse(DateTimeStop(0),DateTimeStop(1)) Then
						ActiveHeater=True
						SchedulerZoneTemp= ListofScheduler.Get("SchedulerTemp")
						Log("Activation par date Start/Stop")
					End If
						
				Else 'Activation par programmation jour semaine
					
					DaysList= ListofScheduler.Get("SchedulerDays")
					
					Private Repeat() As String = Regex.Split(";",ListofScheduler.Get("SchedulerRepeat"))
					
					For Each InfoDays As String In DaysList
						
						If  InfoDays.Contains("/")=False Then 'Vérifie s'il faut activer le programme
							
							'*********************Vérification date begining
							If (DateTime.DateParse(InfoDays)= DateTime.DateParse(DateTime.date(DateTime.Now))) Or _
							 (DateTime.DateParse(DateTime.date(DateTime.Now))>DateTime.DateParse(InfoDays) And Repeat(0)=True And DateTime.DateParse(DateTime.date(DateTime.Now))<=DateTime.DateParse(Repeat(1))) _
							 Or (Repeat(0)=True And Repeat(1)="-") Then
								ValideDate=True
							End If
							
						Else ' *******************Vérification du jour et de la plage horaire
							If 	ValideDate=True Then
								
								Private Detail() As String= Regex.Split("/",InfoDays)
								Private NowDay As String = DateUtils.GetDayOfWeekName(DateTime.Now)
								Private NbPlage As Int=0
								
								Select Case Detail(0)
									Case "Mo"
										If NowDay="Monday" Then
											NbPlage=Detail(1)
											For h= 2 To Detail.Length-1
												Private detail_H() As String= Regex.Split("-", Detail(h))
												If DateTime.TimeParse(DateTime.Time(DateTime.Now))>=DateTime.TimeParse(detail_H(0)) And DateTime.TimeParse(DateTime.Time(DateTime.Now))<DateTime.TimeParse(detail_H(1)) Then
													ActiveHeater=True
													SchedulerZoneTemp= ListofScheduler.Get("SchedulerTemp")
													Exit
												End If
											Next
										End If
									Case "Tu"
										If NowDay="Tuesday" Then
											NbPlage=Detail(1)
											For h= 2 To Detail.Length-1
												Private detail_H() As String= Regex.Split("-", Detail(h))
												If DateTime.TimeParse(DateTime.Time(DateTime.Now))>=DateTime.TimeParse(detail_H(0)) And DateTime.TimeParse(DateTime.Time(DateTime.Now))<DateTime.TimeParse(detail_H(1)) Then
													ActiveHeater=True
													SchedulerZoneTemp= ListofScheduler.Get("SchedulerTemp")
													Exit
												End If
											Next
										End If
										
									Case "We"
										If NowDay="Wednesday" Then
											NbPlage=Detail(1)
											For h= 2 To Detail.Length-1
												Private detail_H() As String= Regex.Split("-", Detail(h))
												If DateTime.TimeParse(DateTime.Time(DateTime.Now))>=DateTime.TimeParse(detail_H(0)) And DateTime.TimeParse(DateTime.Time(DateTime.Now))<DateTime.TimeParse(detail_H(1)) Then
													ActiveHeater=True
													SchedulerZoneTemp= ListofScheduler.Get("SchedulerTemp")
													Exit
												End If
											Next
										End If
									Case "Th"
										If NowDay="Thursday" Then
											NbPlage=Detail(1)
											For h= 2 To Detail.Length-1
												Private detail_H() As String= Regex.Split("-", Detail(h))
												If DateTime.TimeParse(DateTime.Time(DateTime.Now))>=DateTime.TimeParse(detail_H(0)) And DateTime.TimeParse(DateTime.Time(DateTime.Now))<DateTime.TimeParse(detail_H(1)) Then
													ActiveHeater=True
													SchedulerZoneTemp= ListofScheduler.Get("SchedulerTemp")
													Exit
												End If
											Next
										End If
									Case "Fr"
										If NowDay="Friday" Then
											NbPlage=Detail(1)
											For h= 2 To Detail.Length-1
												Private detail_H() As String= Regex.Split("-", Detail(h))
												If DateTime.TimeParse(DateTime.Time(DateTime.Now))>=DateTime.TimeParse(detail_H(0)) And DateTime.TimeParse(DateTime.Time(DateTime.Now))<DateTime.TimeParse(detail_H(1)) Then
													ActiveHeater=True
													SchedulerZoneTemp= ListofScheduler.Get("SchedulerTemp")
													Exit
												End If
											Next
										End If
									Case "Sa"
										If NowDay="Saturday" Then
											NbPlage=Detail(1)
											For h= 2 To Detail.Length-1
												Private detail_H() As String= Regex.Split("-", Detail(h))
												If DateTime.TimeParse(DateTime.Time(DateTime.Now))>=DateTime.TimeParse(detail_H(0)) And DateTime.TimeParse(DateTime.Time(DateTime.Now))<DateTime.TimeParse(detail_H(1)) Then
													ActiveHeater=True
													SchedulerZoneTemp= ListofScheduler.Get("SchedulerTemp")
													Exit
												End If
											Next
										End If
									Case "Su"
										If NowDay="Sunday" Then
											NbPlage=Detail(1)
											For h= 2 To Detail.Length-1
												Private detail_H() As String= Regex.Split("-", Detail(h))
												If DateTime.TimeParse(DateTime.Time(DateTime.Now))>=DateTime.TimeParse(detail_H(0)) And DateTime.TimeParse(DateTime.Time(DateTime.Now))<DateTime.TimeParse(detail_H(1)) Then
													ActiveHeater=True
													SchedulerZoneTemp= ListofScheduler.Get("SchedulerTemp")
													Exit
												End If
											Next
										End If
										
								End Select
															
							End If
							
						End If
						
					Next
					
				End If
					
			End If

		Next
	Catch
		Log(LastException)
	End Try
	
	Private SetTempZone() As String
	
	Private NbZone As Int
	
	
	Try
		Private MinSetTempZone() As String =Regex.Split("/",ServerMQTT.HeaterSetup.Get("HeaterMinTemp"))
		'Private MinNbZone As Int= MinSetTempZone(0)
	
		If ActiveHeater=True Then 'Si Scheduler activé, on récupère la température de consigne
			SetTempZone=Regex.Split("/",SchedulerZoneTemp)
			NbZone= SetTempZone(0)
			
			'Met à jour la conf local du chauffage avec les valeurs de températures définies
			If ServerMQTT.LocalHeaterSetup.get("SchedulerActif")=False Then
				ServerMQTT.LocalHeaterSetup.Put("HeaterSetTemp",SchedulerZoneTemp)
				ServerMQTT.LocalHeaterSetup.Put("SchedulerActif",True)
				Private jg As JSONGenerator
				jg.Initialize(ServerMQTT.localHeaterSetup)
				File.WriteString(File.DirDefaultExternal,"LocalHeater-Setup.json",jg.ToPrettyString(4))
			Else
				SetTempZone=Regex.Split("/",ServerMQTT.LocalHeaterSetup.get("HeaterSetTemp"))
				NbZone= SetTempZone(0)
			End If
			
		Else 'Sinon on récupère la température de consigne mini . (hors programme)
			Log(">>>>>>>>> Chauffage Off Consigne Min >>>>>>>>>")
			SetTempZone=Regex.Split("/",ServerMQTT.HeaterSetup.Get("HeaterMinTemp"))
			NbZone= MinSetTempZone(0)
		End If
	
		'Private TempConsigne As  Double
		
		'Dim MapDataDevice As Map
		Log(">>>> Ennumeration des zones")
		For z1 =1 To NbZone 'Enumére chaque zone
			Private ZoneTemp() As String= Regex.Split(";",SetTempZone(z1))
			Private ConsigneTemp As Double=ZoneTemp(1)
			
			For Each infoDevice In ServerMQTT.ListStatusDevice
				Private InfosDevices() As String= Regex.Split(";",infoDevice)
			
				Private DeviceId As String = ""
				If InfosDevices(1).StartsWith("*")=True Then
					DeviceId = InfosDevices(1).SubString(1)
				Else
					DeviceId=InfosDevices(1)
				End If
		
			
				If (InfosDevices(0) = ZoneTemp(0)) Or ZoneTemp(0)="All" Then 'Identifie la zone
					If InfosDevices(4)<>-1 Then 'Vérifie si le device à un status connecté
					
						If InfosDevices(3)<>"-" Then 'Vérifie que la sonde de Temp a bien remonté une valeur
							If InfosDevices(3).Contains("shelly1")=False Then
													
								If InfosDevices(3).SubString(1)<ConsigneTemp  Then 'si la température mesurée < à la consigne, alors on active le chauffage, s'il ne l'est pas
									
									If InfosDevices(2)="off" Then ' 0 = chauffage arrêté
										Private DeviceIdCde As String= "shellies/" & DeviceId & "/relay/0/command"
										If ServerMQTT.connected=True Then
											Log(">>>>>>>>> Chauffage activé >>>>>>>>>")
											Log("Zone: " & ZoneTemp(0))
											Log("Température de consigne: " & ConsigneTemp & "  " & DeviceIdCde)
											CallSub3(ServerMQTT,"sendmessage",DeviceIdCde,"on")
											Sleep(100)
										End If
									End If
									
								Else If InfosDevices(3).SubString(1)>=ConsigneTemp Then
									
									If InfosDevices(2)="on" Then ' 0 = chauffage arrêté
										Private DeviceIdCde As String= "shellies/" & DeviceId & "/relay/0/command"
										If ServerMQTT.connected=True Then
											Log(">>>>>>>>> Chauffage désactivé >>>>>>>>>")
											Log("Zone: " & ZoneTemp(0))
											Log("Température de consigne: " & ConsigneTemp & "  " & DeviceIdCde)
											CallSub3(ServerMQTT,"sendmessage",DeviceIdCde,"off")
											Sleep(100)
										End If
									End If
								
								End If
							End If
					
						Else If InfosDevices(3)="-" Then
							Log("La sonde de température ne fonctionne pas : " & DeviceId)
						End If
					End If
				End If
			Next
			'End If
		Next
	Catch
		Log(LastException)
	End Try
	
	

	StopService(Me)
	
End Sub

Sub Service_Destroy
	
End Sub
